////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Arduino UNO,Pro mini
//
////////////////////////
//ПАУК (ГЕКСАПОД) 3 СЕРВОПРИВОДА ТЕСТ
//
#include <Servo.h>
byte dd=10;//амплитуда ходьбы
byte n=5;// постоянная временного интервала
byte i=0;//счётчик
byte j=0;//счётчик
byte a=90;//угол "серединный"
byte b=90;//угол "серединный"
byte c=98;//угол "серединный"


long Y=0;//переменная хранения моментов времени

int tabl[]={-4*dd/5,-3*dd/5,-2*dd/5,-dd/5,0,dd/5,2*dd/5,3*dd/5,4*dd/5,dd,dd,dd,dd,dd,dd,dd,dd,dd,dd,dd,
4*dd/5,3*dd/5,2*dd/5,dd/5,0,-dd/5,-2*dd/5,-3*dd/5,-4*dd/5,-dd,-dd,-dd,-dd,-dd,-dd,-dd,-dd,-dd,-dd,-dd};//массив последовательности приращений углов
int DL = sizeof(tabl) / sizeof(tabl[0]);//количество элементов массива
int tabl_sm_1[]={DL/4,3*DL/4,DL/4,3*DL/4,DL/4,3*DL/4,0};//массив-смещение последовательности приращений углов ВПЕРЁД(sm_1=DL/4,sm_2=0);НАЗАД(sm_1=3*DL/4,sm_2=0)
int tabl_sm_2[]={0,0,DL/2,DL/2,DL/5,DL/5,0};//массив-смещение последовательности приращений углов ВПРАВО(sm_1=DL/4,sm_2=DL/2);ВЛЕВО(sm_1=3*DL/4,sm_2=DL/2) 

String inputString;// строки данных
byte SOST_=4;// ФЛАГ СОСТОЯНИЯ ДВИЖЕНИЯ

////////////////////////////
Servo servo_a;
Servo servo_b;
Servo servo_c;

void setup()
{
  Serial.begin(9600);
  
  servo_a.attach(5);//вывод управления сервоприводом ПРАВАЯ ПАРА
  servo_a.write(a);// установка начального значения
  
  servo_b.attach(6);//вывод управления сервоприводом ЛЕВАЯ ПАРА
  servo_b.write(b);// установка начального значения
  
  servo_c.attach(7);//вывод управления сервоприводом ЦЕНТРАЛЬНАЯ ПАРА
  servo_c.write(c);// установка начального значения
 }
/////////////////////////////////////////////////////////////////////////////////////////
void loop()
{
 if(SOST_==4){delay_(50*n);}//состояние покоя
 if(SOST_==0){dvig(tabl_sm_1[0],tabl_sm_2[0]);}//вперёд 
 if(SOST_==1){dvig(tabl_sm_1[1],tabl_sm_2[1]);}//назад
 if(SOST_==2){dvig(tabl_sm_1[2],tabl_sm_2[2]);}//вправо
 if(SOST_==3){dvig(tabl_sm_1[3],tabl_sm_2[3]);}//влево
 if(SOST_==5){dvig(tabl_sm_1[4],tabl_sm_2[4]);}//вперёд-вправо
 if(SOST_==6){dvig(tabl_sm_1[5],tabl_sm_2[5]);}//назад-вправо
 if(SOST_==7){dvig(tabl_sm_1[5],tabl_sm_2[5]);}//назад-влево
 if(SOST_==8){dvig(tabl_sm_1[4],tabl_sm_2[4]);}//вперёд-влево
 if(SOST_==9){dvig(tabl_sm_1[6],tabl_sm_2[6]);}//топтание на месте  
}
/////////////////////////////////////////////////////////////////////////////////////////
void dvig(int sm_1,int sm_2){
  for(i=0;i<DL;i++)
  {
  if(i+sm_2>=DL){servo_a.write(a+tabl[i+sm_2-DL]);}else{servo_a.write(a+tabl[i+sm_2]);}
  servo_b.write(b+tabl[i]);
  if(i+sm_1>=DL){servo_c.write(c+tabl[i+sm_1-DL]);}else{servo_c.write(c+tabl[i+sm_1]);}
  delay_(2*n); 
  }

}
///////////////////////////////////////////////////////////////////////////////////////
////  ФУНКЦИИ ОПИСАНИЕ // вместо задержки времени через delay  ////////////////////////////////////////
void delay_(int T1)
{
 Y=millis();
 while(millis()-Y<T1) 
  {
     CheckSerial();//ЖДЁМ ПОСТУПЛЕНИЯ КОМАНДЫ 
   }
}
 ////////////////////////////////////////////////////////////////////
 /////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
  //////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
  int y = inputString.length(); // присваиваем переменной у число символов в строке
  if (y < 1 || y > 1)return; //если их меньше 1 или больше, выходим из функции
  String cmd = inputString; // передаём строку другой переменной
  inputString = "";//"обнуляем переменную"

  if (cmd == "1") {
  SOST_=0;  
  }
  if (cmd == "2") {
   SOST_=1;servo_a.detach();servo_b.detach();servo_a.attach(5);servo_b.attach(6); 
    
  }
  if (cmd == "3") {
   SOST_=2;servo_a.detach();servo_b.detach();servo_a.attach(5);servo_b.attach(6);
  }
  if (cmd == "4") {
   SOST_=3;servo_a.detach();servo_b.detach();servo_a.attach(5);servo_b.attach(6);
  }
  if (cmd == "A") {
  SOST_=4;servo_a.detach();servo_b.detach();servo_a.attach(5);servo_b.attach(6); 
  }
  if (cmd == "5") {
   SOST_=5;servo_a.detach();servo_b.detach();servo_a.attach(5);servo_b.attach(6);
  }
  if (cmd == "6") {
   SOST_=6;servo_a.detach();servo_b.detach();servo_a.attach(5);servo_b.attach(6);
  }
  if (cmd == "7") {
   SOST_=7;servo_a.detach();servo_b.detach();servo_a.attach(6);servo_b.attach(5);
  }
  if (cmd == "8") {
   SOST_=8;servo_a.detach();servo_b.detach();servo_a.attach(6);servo_b.attach(5);
  }
  if (cmd == "9") {
   SOST_=9;servo_a.detach();servo_b.detach();servo_a.attach(5);servo_b.attach(6);
  }
  if (cmd == "B") {
   n=n+5;if(n>15){n=5;}
  } 
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

